// audio level meter
// main.c (file 2 of 2)


#include "main.h"


//---------------------------------------------------------------------------------------
void led_con(uint8_t num, uint8_t color)  //color: 2==RED, 1==GREEN
	{
	switch(num)
		{
		case 0:  if(color==2) { C0LD0_RED; } else if(color==1) { C0LD0_GRN; } break;
		case 1:  if(color==2) { C0LD1_RED; } else if(color==1) { C0LD1_GRN; } break;
		case 2:  if(color==2) { C0LD2_RED; } else if(color==1) { C0LD2_GRN; } break;
		case 3:  if(color==2) { C0LD3_RED; } else if(color==1) { C0LD3_GRN; } break;
		case 4:  if(color==2) { C0LD4_RED; } else if(color==1) { C0LD4_GRN; } break;
		case 5:  if(color==2) { C0LD5_RED; } else if(color==1) { C0LD5_GRN; } break;
		case 6:  if(color==2) { C0LD6_RED; } else if(color==1) { C0LD6_GRN; } break;
		case 7:  if(color==2) { C0LD7_RED; } else if(color==1) { C0LD7_GRN; } break;
		case 8:  if(color==2) { C0LD8_RED; } else if(color==1) { C0LD8_GRN; } break;
		//
		case 9:  if(color==2) { C1LD0_RED; } else if(color==1) { C1LD0_GRN; } break;
		case 10: if(color==2) { C1LD1_RED; } else if(color==1) { C1LD1_GRN; } break;
		case 11: if(color==2) { C1LD2_RED; } else if(color==1) { C1LD2_GRN; } break;
		case 12: if(color==2) { C1LD3_RED; } else if(color==1) { C1LD3_GRN; } break;
		case 13: if(color==2) { C1LD4_RED; } else if(color==1) { C1LD4_GRN; } break;
		case 14: if(color==2) { C1LD5_RED; } else if(color==1) { C1LD5_GRN; } break;
		case 15: if(color==2) { C1LD6_RED; } else if(color==1) { C1LD6_GRN; } break;
		case 16: if(color==2) { C1LD7_RED; } else if(color==1) { C1LD7_GRN; } break;
		case 17: if(color==2) { C1LD8_RED; } else if(color==1) { C1LD8_GRN; } break;
		}	
	}


//-------------------------------------------------------------------------------------------------
void interrupt handler(void)
	{	
	if(TMR0IF && TMR0IE)  //****************  timer0 overflow interrupt ~1kHz  ********************
		{
		TMR0IF=0;
		TMR0=TMR0_LOAD;
		
		
		/////////////////////////////////////  Peak Hold timer  ///////////////////////////////////
		static uint16_t pcnt=0;
		
		if(++pcnt>PH_CONST)
			{
			pcnt=0;
			if(p0>=0) p0--;
			if(p1>=9) p1--;
			}
		
		/////////////////////////////////////  LED multiplexing  //////////////////////////////////
		
		LEDM_OFF;
		
		if(muxcnt & 0b00000011)  {  if(opmod==0) { LEDM_GRN; }  }
		  else  {  if(opmod==1) { LEDM_RED; }  }
		
		LED_ALL_OFF;
		
		led_con(muxcnt, leds[muxcnt]);
		
		if(muxcnt==16) msrun=1;
		if(muxcnt==17) conrun=1;
		
		if(++muxcnt>17) muxcnt=0;
		
		///////////////////////////////////////  Button  //////////////////////////////////////////
		static uint8_t buthold=0;
		
		if(BUTTON) //if button is pressed
			{
			if(++butcnt>=BUT_HLD)
				{
				butcnt=0;
				butst=2; //long press
				buthold=1;
				}
			}
		else
			{
			if(butcnt>=BUT_DEB && buthold==0) butst=1; //short press
			buthold=0;
			butcnt=0;
			}
		}
	}


//---------------------------------------------------------------------------------------
void delay_ms(uint16_t val)  //delay milliseconds
	{
	while(val--) __delay_ms(1);
	}


//---------------------------------------------------------------------------------------
void led_test(uint8_t delay, uint8_t color)  //delay x10ms
	{
	for(uint8_t k=0; k<18; k++) leds[k]=color;
	muxcnt=0;
	delay_ms((uint16_t)delay*10U);
	}


//---------------------------------------------------------------------------------------
void setup(void) //init MCU
	{
	IRCF2=1; IRCF1=1; IRCF0=1; //8MHz internal RC oscillator  //Fosc
	
	SWDTEN=0; //disable watchdog timer
	
	RBPU=0; //enable pull-up on PORTB
	
	BUTTON_INIT;
	TL431_INIT;
	LEDM_INIT;
	LEDM_GRN;

	ADCON2 = 0b10111110; //A/D Result Format  //6-N/A  //111=20TAD  //110=FOSC/64
	ADCON1 = 0b011101; //Voltage Reference - pin AN3 //Port Configuration - pin AN0,AN1
	ADCON0 = 0b000001; //Channel 0  //A/D converter module is enabled

	//TMR0ON T08BIT T0CS T0SE PSA T0PS2 T0PS1 T0PS0
	T0CON=0b10010011; //prescaler 011 - 1:16  Fosc/4=2000, 2000/16=125kHz
	TMR0=TMR0_LOAD; //preload
	TMR0IE=1; //timer0 overflow intterrupt enable
	
	PEIE=1; //enable interrupts
	GIE=1;
	
	led_test(120,GREEN);
	}


//---------------------------------------------------------------------------------------
int main(void)
	{
	setup();
	
	uint16_t chan0=0;  //ADC result for two channels
	uint16_t chan1=0;
	
	for(;;) //main loop
		{
		if(msrun)  ///////////////////////  measurement  //////////////////////
			{	
			ADCON0 = 0b000001;  //select AN0
			GODONE=1;           //start ADC
			while(GODONE);      //wait end of ADC
			chan0=ADRES;        //ADC result
			
			ADCON0 = 0b000101;  //select AN1
			GODONE=1;
			while(GODONE);
			chan1=ADRES;
			
			msrun=0;
			}
		
		if(conrun)  /////////////////////  converting  ////////////////////////
			{
			for(uint8_t k=0; k<18; k++)
				{
				uint8_t t=0;
				
				if(k<9) { t=k; }
				  else  { t=k-9; chan1=chan0; }
				
				leds[k]=0;  //buffer cleaning
				
				if(chan1>=levels[opmod][t])
					{
					leds[k]=GREEN;
					if(chan1<levels[opmod][t+1])
						{
						if(k<9) { if(k>p0) p0=k; }
						  else  { if(k>p1) p1=k; }
						}
					}
				}	
			
			if(p0>=0) leds[p0]=RED;
			if(p1>=9) leds[p1]=RED;
			
			conrun=0;
			}
		
		switch(butst) /////////////////////  button  //////////////////////////
			{
			case 2:  //long press  //do nothing
				led_test(40,opmod+1);
				butcnt=0; 
				butst=0;
				break;
			//
			case 1:  //short press  //change the mode
				butst=0; //button reset
				if(++opmod>1) opmod=0;
				led_test(20,opmod+1);
				break;
			}
		}
	}

